#include "pump.hpp"


void Pump::init()
{
  state=0;
  state_sauv=0;
  stop=0;
  stop_p=false;
}


short Pump::getStop ()
{
  return stop;
}

bool Pump::getStop_p ()
{
  return stop_p;
}

void Pump::setStop(short stop)
{
  this->stop=stop;
}

void Pump::setStop_p (bool stop_p)
{
  this->stop_p=stop_p;
}

  
void Pump::forceState(short forcedState,connexion &c,K8055 &k,config &cfg)
{
  if (state!=forcedState)
    {
      state_sauv=state;
      state=forcedState;
      k.change_state(c, cfg.OUTPUMP,state,"Grp Pompe forced");
    }
}

void Pump::bouttonApp ()
{
  time (&t_timer);
  stop_p=true;
}

void Pump::stop10 (connexion &c,K8055 &k,config &cfg)
{
  time (&rawtime);
  double dif = difftime (rawtime,t_timer);
//if timer >10 min
  if( (dif/60) > 10.0) 
    {
      stop_p=false;
    }
  else
//stop the pump if running    
    if (state==1)
	{
	  state=0;
  	  state_sauv=state;
	  k.change_state(c, cfg.OUTPUMP,state,"Grp Pompe stopp 10min:");
	}
}

void Pump::changeState (short state ,connexion &c ,K8055 &k,config &cfg)
{
  this->state=state;
  state_sauv=state;
  k.change_state(c, cfg.OUTPUMP,state,"Grp Pompe");
}


void Pump::changing(short st,connexion &c,K8055 &k,config &cfg )
{
  //cout << "etat du groupe de pompe " << endl;
  if (cfg.forced_pump!=0)
      forceState (cfg.forced_pump-1,c,k,cfg);
  else
  {
  	if (state!=state_sauv)
    		changeState(state_sauv,c,k,cfg);
	if (stop==1)
      		bouttonApp();
  	if (stop_p==true)
    		stop10(c,k,cfg);
  	else if (state!=st)
	{
		changeState (st,c,k,cfg);}
   }
}
