-- phpMyAdmin SQL Dump
-- version 2.9.1.1-Debian-3
-- http://www.phpmyadmin.net
-- 
-- Serveur: localhost
-- Généré le : Dimanche 07 Octobre 2007 à 20:26
-- Version du serveur: 5.0.32
-- Version de PHP: 5.2.0-8+etch4
-- 
-- Base de données: `automate`
-- 

-- --------------------------------------------------------

-- 
-- Structure de la table `destinataire`
-- 

CREATE TABLE `destinataire` (
  `id` tinyint(4) NOT NULL auto_increment,
  `tel` varchar(11) NOT NULL default '',
  PRIMARY KEY  (`id`),
  FULLTEXT KEY `tel` (`tel`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

-- 
-- Contenu de la table `destinataire`
-- 

INSERT INTO `destinataire` (`id`, `tel`) VALUES 
(1, '0000000000');

-- --------------------------------------------------------

-- 
-- Structure de la table `error`
-- 

CREATE TABLE `error` (
  `id` int(11) NOT NULL auto_increment,
  `date` date NOT NULL default '0000-00-00',
  `time` time NOT NULL default '00:00:00',
  `type` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COMMENT='error class' AUTO_INCREMENT=9 ;

-- 
-- Contenu de la table `error`
-- 


-- --------------------------------------------------------

-- 
-- Structure de la table `log`
-- 

CREATE TABLE `log` (
  `id` bigint(20) NOT NULL auto_increment,
  `date` date NOT NULL default '0000-00-00',
  `time` time NOT NULL default '00:00:00',
  `message` varchar(150) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=52367 ;

-- 
-- Contenu de la table `log`
-- 


-- --------------------------------------------------------

-- 
-- Structure de la table `login`
-- 

CREATE TABLE `login` (
  `id` tinyint(4) NOT NULL auto_increment,
  `nom` varchar(20) NOT NULL default '',
  `pass` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=5 ;

-- 
-- Contenu de la table `login`
-- 

INSERT INTO `login` (`id`, `nom`, `pass`) VALUES 
(3, 'admin', 'admin'),
(4, 'invite', 'invite');

-- --------------------------------------------------------

-- 
-- Structure de la table `osmolation`
-- 

CREATE TABLE `osmolation` (
  `id` bigint(20) NOT NULL auto_increment,
  `day` date NOT NULL default '0000-00-00',
  `time` time NOT NULL default '00:00:00',
  `timeend` time NOT NULL default '00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='osmolation table' AUTO_INCREMENT=1 ;

-- 
-- Contenu de la table `osmolation`
-- 


-- --------------------------------------------------------

-- 
-- Structure de la table `parametres`
-- 

CREATE TABLE `parametres` (
  `id` tinyint(4) NOT NULL auto_increment,
  `nom` text NOT NULL,
  `timerdebut` time NOT NULL default '00:00:00',
  `timerfin` time NOT NULL default '00:00:00',
  `button` tinyint(3) unsigned NOT NULL default '0',
  `config` text NOT NULL,
  `nb` tinyint(4) NOT NULL default '0',
  `forced` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COMMENT='parameters table' AUTO_INCREMENT=128 ;

-- 
-- Contenu de la table `parametres`
-- 

INSERT INTO `parametres` (`id`, `nom`, `timerdebut`, `timerfin`, `button`, `config`, `nb`, `forced`) VALUES 
(1, 'hqi', '12:00:00', '22:00:00', 1, 'init', 0, 0),
(2, 'blue', '15:00:00', '09:00:00', 1, 'init', 0, 0),
(3, 'pump', '09:30:00', '20:30:00', 1, 'init', 0, 0),
(4, 'rah', '00:15:00', '02:30:00', 1, 'init', 0, 0),
(5, 'pdoseuse', '19:40:50', '19:41:00', 1, 'init', 1, 0),
(6, 'pdoseuse', '20:15:50', '20:16:00', 1, 'init', 2, 0),
(7, 'pdoseuse', '00:00:00', '00:00:00', 0, 'init', 3, 0),
(8, 'pdoseuse', '00:00:00', '00:00:00', 0, 'init', 4, 0),
(9, 'pdoseuse', '00:00:00', '00:00:00', 0, 'init', 5, 0),
(10, 'mail', '00:00:00', '00:00:00', 0, 'salva@iut.u-clermont1.fr', 2, 0),
(11, 'mail', '00:00:00', '00:00:00', 0, 'sebastien.salva@freesbee.fr', 1, 0),
(12, 'mail', '00:00:00', '00:00:00', 0, 'smtp', 3, 0),
(13, 'input', '00:00:00', '00:00:00', 0, 'stop_pump', 1, 0),
(14, 'input', '00:00:00', '00:00:00', 0, 'flowmeter', 2, 0),
(15, 'input', '00:00:00', '00:00:00', 0, 'osmolation', 3, 0),
(16, 'input', '00:00:00', '00:00:00', 0, 'reserv', 4, 0),
(17, 'input', '00:00:00', '00:00:00', 0, 'high', 5, 0),
(18, 'output', '00:00:00', '00:00:00', 1, 'vent', 1, 0),
(19, 'output', '00:00:00', '00:00:00', 1, 'pump', 2, 0),
(20, 'output', '00:00:00', '00:00:00', 0, 'osmolation', 3, 0),
(21, 'output', '00:00:00', '00:00:00', 1, 'skimmer', 4, 0),
(22, 'output', '00:00:00', '00:00:00', 0, '', 5, 0),
(23, 'output', '00:00:00', '00:00:00', 0, 'temp', 6, 0),
(24, 'output', '00:00:00', '00:00:00', 0, 'peri', 7, 0),
(25, 'output', '00:00:00', '00:00:00', 1, 'blue', 8, 0),
(26, 'osmolation', '00:00:00', '00:00:00', 0, '66', 30, 0),
(27, 'debitosmolation', '00:00:00', '00:00:00', 0, '66', 0, 0),
(28, 'starthqi', '00:00:00', '00:00:00', 0, '', 2, 0),
(127, 'start', '00:00:00', '00:00:00', 0, '', 0, 0),
(30, 'thqi', '00:00:00', '00:00:00', 0, '29', 0, 0),
(32, 'osmolation', '00:00:00', '00:00:00', 0, 'init', 30, 0),
(33, 'heating', '00:00:00', '00:00:00', 0, 'init', 0, 0),
(34, 'flowmeter', '00:00:00', '00:00:00', 0, '1800.0', 0, 0),
(35, 'sms', '00:00:00', '00:00:00', 0, '0', 0, 0),
(36, 'lcd', '00:00:00', '00:00:00', 0, '0', 0, 0),
(37, 'ventilator', '00:00:00', '00:00:00', 0, '27.5', 0, 0),
(38, 'loglcd', '00:00:00', '00:00:00', 0, '0', 0, 0),
(39, 'skimmer', '15:00:00', '15:00:00', 1, 'init', 0, 0),
(40, 'ph', '00:00:00', '00:00:00', 0, '1', 0, 0),
(41, 'phminalarm', '00:00:00', '00:00:00', 0, '7', 0, 0),
(42, 'phmaxalarm', '00:00:00', '00:00:00', 0, '8.8', 0, 0);

-- --------------------------------------------------------

-- 
-- Structure de la table `ph`
-- 

CREATE TABLE `ph` (
  `t` double(4,1) NOT NULL default '0.0',
  `nom` char(10) NOT NULL default '',
  `i` int(11) NOT NULL default '0',
  PRIMARY KEY  (`nom`,`i`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Contenu de la table `ph`
-- 

INSERT INTO `ph` (`t`, `nom`, `i`) VALUES 
(7.7, 'current', 0),
(7.4, 'day', 0),
(-23.0, 'min', 14),
(77.6, 'max', 14),
(7.4, 'day', 1),
(7.4, 'day', 2),
(7.4, 'day', 3),
(7.4, 'day', 4),
(7.4, 'day', 5),
(7.5, 'day', 6),
(7.5, 'day', 7),
(7.5, 'day', 8),
(7.4, 'day', 9),
(7.4, 'day', 10),
(7.4, 'day', 11),
(7.4, 'day', 12),
(7.5, 'day', 13),
(7.5, 'day', 14),
(7.6, 'day', 15),
(7.6, 'day', 16),
(7.6, 'day', 17),
(7.6, 'day', 18),
(7.6, 'day', 19),
(7.6, 'day', 20),
(7.6, 'day', 21),
(7.4, 'day', 22),
(7.5, 'day', 23),
(-23.0, 'min', 13),
(77.6, 'max', 13),
(-23.0, 'min', 22),
(77.6, 'max', 22),
(-23.0, 'min', 23),
(77.6, 'max', 23),
(-23.0, 'min', 0),
(77.6, 'max', 0),
(-23.0, 'min', 1),
(77.6, 'max', 1),
(-23.0, 'min', 2),
(77.6, 'max', 2),
(-23.4, 'min', 3),
(77.6, 'max', 3),
(-23.4, 'min', 4),
(77.6, 'max', 4),
(-23.4, 'min', 5),
(77.6, 'max', 5),
(-23.0, 'min', 6),
(77.6, 'max', 6),
(-23.0, 'min', 7),
(77.6, 'max', 7),
(-23.0, 'min', 8),
(77.6, 'max', 8),
(-23.0, 'min', 9),
(77.6, 'max', 9),
(-23.0, 'min', 10),
(77.6, 'max', 10),
(-23.0, 'min', 11),
(77.6, 'max', 11),
(-23.0, 'min', 12),
(77.6, 'max', 12),
(-23.0, 'min', 15),
(77.6, 'max', 15),
(-23.0, 'min', 16),
(77.6, 'max', 16),
(-23.0, 'min', 17),
(77.6, 'max', 17),
(-23.0, 'min', 18),
(77.6, 'max', 18),
(-23.0, 'min', 19),
(77.6, 'max', 19),
(-23.0, 'min', 20),
(77.6, 'max', 20),
(-23.0, 'min', 21),
(77.6, 'max', 21),
(-0.1, 'correction', 0),
(0.0, 'calibre', 0);

-- --------------------------------------------------------

-- 
-- Structure de la table `prestataire`
-- 

CREATE TABLE `prestataire` (
  `id` tinyint(4) NOT NULL auto_increment,
  `nom` varchar(20) NOT NULL default '',
  `hote` varchar(100) NOT NULL default '',
  `script` varchar(100) NOT NULL default '',
  `login` varchar(100) NOT NULL default '',
  `pass` varchar(10) NOT NULL default '',
  `selec` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  FULLTEXT KEY `nom` (`nom`),
  FULLTEXT KEY `login` (`login`,`pass`),
  FULLTEXT KEY `hote` (`hote`,`script`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=5 ;

-- 
-- Contenu de la table `prestataire`
-- 

INSERT INTO `prestataire` (`id`, `nom`, `hote`, `script`, `login`, `pass`, `selec`) VALUES 
(3, 'tm4b', 'tm4b.com', '/client/api/http.php', 'login', 'pass', 0),
(4, 'leSMS', 'leSMS.com', '/http.php', 'login', 'pass', 1);

-- --------------------------------------------------------

-- 
-- Structure de la table `temperature`
-- 

CREATE TABLE `temperature` (
  `t` double(4,1) NOT NULL default '0.0',
  `nom` char(10) NOT NULL default '',
  `i` int(11) NOT NULL default '0',
  PRIMARY KEY  (`nom`,`i`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Contenu de la table `temperature`
-- 

INSERT INTO `temperature` (`t`, `nom`, `i`) VALUES 
(27.5, 'current', 0),
(27.1, 'day', 0),
(-23.0, 'min', 14),
(77.6, 'max', 14),
(27.1, 'day', 1),
(26.7, 'day', 2),
(27.1, 'day', 3),
(26.7, 'day', 4),
(26.7, 'day', 5),
(26.7, 'day', 6),
(26.7, 'day', 7),
(26.7, 'day', 8),
(26.7, 'day', 9),
(26.7, 'day', 10),
(26.7, 'day', 11),
(26.7, 'day', 12),
(26.7, 'day', 13),
(27.1, 'day', 14),
(27.1, 'day', 15),
(27.1, 'day', 16),
(27.1, 'day', 17),
(27.1, 'day', 18),
(27.1, 'day', 19),
(27.1, 'day', 20),
(27.5, 'day', 21),
(27.1, 'day', 22),
(27.1, 'day', 23),
(-23.0, 'min', 13),
(77.6, 'max', 13),
(-23.0, 'min', 22),
(77.6, 'max', 22),
(-23.0, 'min', 23),
(77.6, 'max', 23),
(-23.0, 'min', 0),
(77.6, 'max', 0),
(-23.0, 'min', 1),
(77.6, 'max', 1),
(-23.0, 'min', 2),
(77.6, 'max', 2),
(-23.4, 'min', 3),
(77.6, 'max', 3),
(-23.4, 'min', 4),
(77.6, 'max', 4),
(-23.4, 'min', 5),
(77.6, 'max', 5),
(-23.0, 'min', 6),
(77.6, 'max', 6),
(-23.0, 'min', 7),
(77.6, 'max', 7),
(-23.0, 'min', 8),
(77.6, 'max', 8),
(-23.0, 'min', 9),
(77.6, 'max', 9),
(-23.0, 'min', 10),
(77.6, 'max', 10),
(-23.0, 'min', 11),
(77.6, 'max', 11),
(-23.0, 'min', 12),
(77.6, 'max', 12),
(-23.0, 'min', 15),
(77.6, 'max', 15),
(-23.0, 'min', 16),
(77.6, 'max', 16),
(-23.0, 'min', 17),
(77.6, 'max', 17),
(-23.0, 'min', 18),
(77.6, 'max', 18),
(-23.0, 'min', 19),
(77.6, 'max', 19),
(-23.0, 'min', 20),
(77.6, 'max', 20),
(-23.0, 'min', 21),
(77.6, 'max', 21),
(27.5, 'maxmonth', 23),
(27.1, 'minmonth', 23),
(27.9, 'maxmonth', 22),
(27.1, 'minmonth', 22),
(27.5, 'maxmonth', 21),
(27.1, 'minmonth', 21),
(27.5, 'maxmonth', 20),
(27.1, 'minmonth', 20),
(27.9, 'maxmonth', 19),
(27.1, 'minmonth', 19),
(27.5, 'maxmonth', 18),
(27.1, 'minmonth', 18),
(27.5, 'maxmonth', 17),
(27.1, 'minmonth', 17),
(27.5, 'maxmonth', 16),
(26.7, 'minmonth', 16),
(27.1, 'maxmonth', 15),
(26.7, 'minmonth', 15),
(27.1, 'maxmonth', 14),
(26.7, 'minmonth', 14),
(27.1, 'maxmonth', 13),
(26.3, 'minmonth', 13),
(26.7, 'maxmonth', 12),
(26.3, 'minmonth', 12),
(27.1, 'maxmonth', 11),
(25.9, 'minmonth', 11),
(27.1, 'maxmonth', 10),
(26.3, 'minmonth', 10),
(27.1, 'maxmonth', 9),
(26.3, 'minmonth', 9),
(27.1, 'maxmonth', 8),
(26.3, 'minmonth', 8),
(27.1, 'maxmonth', 7),
(26.7, 'minmonth', 7),
(27.1, 'maxmonth', 6),
(26.7, 'minmonth', 6),
(27.1, 'maxmonth', 5),
(26.3, 'minmonth', 5),
(27.1, 'maxmonth', 4),
(26.7, 'minmonth', 4),
(27.1, 'maxmonth', 3),
(26.7, 'minmonth', 3),
(27.1, 'maxmonth', 2),
(26.7, 'minmonth', 2),
(27.5, 'maxmonth', 1),
(26.7, 'minmonth', 1),
(27.5, 'maxmonth', 0),
(27.1, 'minmonth', 0);

-- --------------------------------------------------------

-- 
-- Structure de la table `water`
-- 

CREATE TABLE `water` (
  `type` varchar(20) NOT NULL default '',
  `quantity` double NOT NULL default '0',
  `date` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Contenu de la table `water`
-- 

INSERT INTO `water` (`type`, `quantity`, `date`) VALUES 
('1', 0.0, '0000-00-00'),
('2', 0.0, '0000-00-00'),
('3', 0.0, '0000-00-00'),
('4', 0.0, '0000-00-00'),
('5', 0.0, '0000-00-00'),
('6', 0.0, '0000-00-00'),
('7', 0.0, '0000-00-00'),
('8', 0.0, '0000-00-00'),
('9', 0.0, '0000-00-00'),
('10', 0.0, '0000-00-00'),
('11', 0, '0000-00-00'),
('12', 0.0, '0000-00-00'),
('day', 0.0, '0000-00-00'),
('total', 0.0, '0000-00-00');
